## nvidia-cuda-toolkit 11.2.2

=== cuda_cupti/extras/CUPTI/samples/activity_trace_async/Makefile ===
#
# Copyright 2011-2020 NVIDIA Corporation. All rights reserved
# 
INCLUDES = -I../../../../include -I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths. 
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS), Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):$(LIB_PATH)
    LIBS= -lcuda -L $(LIB_PATH) -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS= -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti
    endif
    OBJ = o
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif
    
    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

# Gencode arguments
SMS ?= 35 37 50 52 53 60 61 62 70 72 75 80 86
# Generate SASS code for each SM architecture listed in $(SMS)
$(foreach sm,$(SMS),$(eval GENCODE_FLAGS += -gencode arch=compute_$(sm),code=sm_$(sm)))

activity_trace_async: activity_trace_async.$(OBJ) vec.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ $^ $(LIBS) $(INCLUDES)

activity_trace_async.$(OBJ): activity_trace_async.cpp
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -c $(INCLUDES) $<

vec.$(OBJ): vec.cu
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) $(GENCODE_FLAGS) -c $(INCLUDES) $<

run: activity_trace_async
	./$<

clean:
	rm -f activity_trace_async activity_trace_async.$(OBJ) vec.$(OBJ)

=== cuda_cupti/extras/CUPTI/samples/autorange_profiling/Makefile ===
#
# Copyright 2017-2018 NVIDIA Corporation. All rights reserved
# 
INCLUDES = -I../../../../include -I../../include -I../extensions/include/profilerhost_util -I../extensions/include/c_util

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths. 
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS), Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS), Windows_NT)
    LIBS = -lcuda -L $(LIB_PATH) -lcupti -lnvperf_host -lnvperf_target -L ..\extensions\src\profilerhost_util -lprofilerHostUtil
    OBJ = obj
    LIBEXT = lib
    LIBPREFIX =
    BINEXT = .exe
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS = -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti -lnvperf_host -lnvperf_target -L ../extensions/src/profilerhost_util -lprofilerHostUtil
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti -lnvperf_host -lnvperf_target -L ../extensions/src/profilerhost_util -lprofilerHostUtil
    endif
    OBJ = o
    LIBEXT = a
    LIBPREFIX = lib
    BINEXT = 
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif

    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

# Gencode arguments
SMS ?= 70 72 75 80 86
# Generate SASS code for each SM architecture listed in $(SMS)
$(foreach sm,$(SMS),$(eval GENCODE_FLAGS += -gencode arch=compute_$(sm),code=sm_$(sm)))

autoRangeSample: simplecuda.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ $^ $(LIBS) $(INCLUDES)

simplecuda.$(OBJ): simplecuda.cu
	nvcc $(NVCC_COMPILER)  $(NVCCFLAGS) $(GENCODE_FLAGS) -c $(INCLUDES) $<

run: autoRangeSample
	./$<

clean:
ifeq ($(OS), Windows_NT)
	del autoRangeSample.exe autoRangeSample.lib autoRangeSample.exp simplecuda.$(OBJ)
else
	rm -f autoRangeSample simplecuda.$(OBJ)
endif

=== cuda_cupti/extras/CUPTI/samples/callback_event/Makefile ===
#
# Copyright 2011-2020 NVIDIA Corporation. All rights reserved
# 
INCLUDES = -I../../../../include -I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths. 
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS), Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):$(LIB_PATH)
    LIBS= -lcuda -L $(LIB_PATH) -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS= -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti
    endif
    OBJ = o
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif
    
    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

# Gencode arguments
SMS ?= 35 37 50 52 53 60 61 62 70 72
# Generate SASS code for each SM architecture listed in $(SMS)
$(foreach sm,$(SMS),$(eval GENCODE_FLAGS += -gencode arch=compute_$(sm),code=sm_$(sm)))

callback_event: callback_event.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ callback_event.$(OBJ) $(LIBS) $(INCLUDES)

callback_event.$(OBJ): callback_event.cu
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) $(GENCODE_FLAGS) -c $(INCLUDES) $<

run: callback_event
	./$<

clean:
	rm -f callback_event callback_event.$(OBJ)

=== cuda_cupti/extras/CUPTI/samples/callback_metric/Makefile ===
#
# Copyright 2011-2020 NVIDIA Corporation. All rights reserved
# 
INCLUDES = -I../../../../include -I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths. 
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS), Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):$(LIB_PATH)
    LIBS= -lcuda -L $(LIB_PATH) -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS= -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti
    endif
    OBJ = o
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif
    
    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

# Gencode arguments
SMS ?= 35 37 50 52 53 60 61 62 70 72
# Generate SASS code for each SM architecture listed in $(SMS)
$(foreach sm,$(SMS),$(eval GENCODE_FLAGS += -gencode arch=compute_$(sm),code=sm_$(sm)))

callback_metric: callback_metric.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ callback_metric.$(OBJ) $(LIBS) $(INCLUDES)

callback_metric.$(OBJ): callback_metric.cu
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) $(GENCODE_FLAGS) -c $(INCLUDES) $<

run: callback_metric
	./$<

clean:
	rm -f callback_metric callback_metric.$(OBJ)

=== cuda_cupti/extras/CUPTI/samples/callback_profiling/Makefile ===
#
# Copyright 2020 NVIDIA Corporation. All rights reserved
# 
INCLUDES = -I../../../../include -I../../include -I../extensions/include/profilerhost_util -I../extensions/include/c_util

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths. 
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS), Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS), Windows_NT)
    LIBS = -lcuda -L $(LIB_PATH) -lcupti -lnvperf_host -lnvperf_target -L ..\extensions\src\profilerhost_util -lprofilerHostUtil
    OBJ = obj
    LIBEXT = lib
    LIBPREFIX =
    BINEXT = .exe
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS = -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti -lnvperf_host -lnvperf_target -L ../extensions/src/profilerhost_util -lprofilerHostUtil
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti -lnvperf_host -lnvperf_target -L ../extensions/src/profilerhost_util -lprofilerHostUtil
    endif
    OBJ = o
    LIBEXT = a
    LIBPREFIX = lib
    BINEXT = 
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif

    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

# Gencode arguments
SMS ?= 70 72 75 80 86
# Generate SASS code for each SM architecture listed in $(SMS)
$(foreach sm,$(SMS),$(eval GENCODE_FLAGS += -gencode arch=compute_$(sm),code=sm_$(sm)))

callback_profiling: callback_profiling.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ $^ $(LIBS) $(INCLUDES)

callback_profiling.$(OBJ): callback_profiling.cu
	nvcc $(NVCC_COMPILER)  $(NVCCFLAGS) $(GENCODE_FLAGS) -c $(INCLUDES) $<

run: callback_profiling
	./$<

clean:
ifeq ($(OS), Windows_NT)
	del callback_profiling.exe callback_profiling.lib callback_profiling.exp callback_profiling.$(OBJ)
else
	rm -f callback_profiling callback_profiling.$(OBJ)
endif

=== cuda_cupti/extras/CUPTI/samples/callback_timestamp/Makefile ===
#
# Copyright 2011-2020 NVIDIA Corporation. All rights reserved
# 
INCLUDES = -I../../../../include -I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths. 
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS),Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):$(LIB_PATH)
    LIBS= -lcuda -L $(LIB_PATH) -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS= -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti
    endif
    OBJ = o
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif
    
    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

# Gencode arguments
SMS ?= 35 37 50 52 53 60 61 62 70 72 75 80 86
# Generate SASS code for each SM architecture listed in $(SMS)
$(foreach sm,$(SMS),$(eval GENCODE_FLAGS += -gencode arch=compute_$(sm),code=sm_$(sm)))


callback_timestamp: callback_timestamp.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ callback_timestamp.$(OBJ) $(LIBS) $(INCLUDES)

callback_timestamp.$(OBJ): callback_timestamp.cu
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) $(GENCODE_FLAGS) -c $(INCLUDES) $<

run: callback_timestamp
	./$<

clean:
	rm -f callback_timestamp callback_timestamp.$(OBJ)

=== cuda_cupti/extras/CUPTI/samples/cuda_graphs_trace/Makefile ===
#
# Copyright 2011-2020 NVIDIA Corporation. All rights reserved
#
INCLUDES = -I../../../../include -I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths.
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS), Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):$(LIB_PATH)
    LIBS= -lcuda -L $(LIB_PATH) -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS= -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti
    endif
    OBJ = o
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif

    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

# Gencode arguments
SMS ?= 35 37 50 52 53 60 61 62 70 72 75 80 86
# Generate SASS code for each SM architecture listed in $(SMS)
$(foreach sm,$(SMS),$(eval GENCODE_FLAGS += -gencode arch=compute_$(sm),code=sm_$(sm)))

cuda_graphs_trace: cuda_graphs_trace.$(OBJ) vec.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ $^ $(LIBS) $(INCLUDES)

cuda_graphs_trace.$(OBJ): cuda_graphs_trace.cpp
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -c $(INCLUDES) $<

vec.$(OBJ): vec.cu
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) $(GENCODE_FLAGS) -c $(INCLUDES) $<

run: cuda_graphs_trace
	./$<

clean:
	rm -f cuda_graphs_trace cuda_graphs_trace.$(OBJ) vec.$(OBJ)

=== cuda_cupti/extras/CUPTI/samples/cupti_finalize/Makefile ===
#
# Copyright 2020 NVIDIA Corporation. All rights reserved
# This sample is for Linux desktop platforms. (Power, x86_64, ARM Server)
#

ifndef OS
OS   := $(shell uname)
HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
    LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
    TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
else
    INCLUDES += -I../../../../include
    INCLUDES += -I../../include
    EXTRAS_LIB_PATH := ../../lib64
    LIB_PATH ?= ../../../../lib64
endif

LIBS :=
ifeq ($(HOST_ARCH), $(TARGET_ARCH))
    LIBS = -L $(EXTRAS_LIB_PATH)
endif
LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti

NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        endif
    endif

    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

FINALIZE_LIB = libCuptiFinalize.so

cupti_finalize: libinject.cpp
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) $(INCLUDES) -o $(FINALIZE_LIB) -Xcompiler -fPIC -shared $< $(LIBS)
	$(info export CUDA_INJECTION64_PATH=<full_path>/libCuptiFinalize.so and run any CUDA sample with runtime more than 10 seconds(Graphics/Simulations samples) for demonstration)
clean:
	rm -f $(FINALIZE_LIB) libinject.o

=== cuda_cupti/extras/CUPTI/samples/cupti_metric_properties/Makefile ===
#
# Copyright 2020 NVIDIA Corporation. All rights reserved
# 
INCLUDES = -I../../../../include -I../../include -I../extensions/include/profilerhost_util -I../extensions/include/c_util

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths. 
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS), Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS), Windows_NT)
    LIBS = -lcuda -L $(LIB_PATH) -lcupti -lnvperf_host -lnvperf_target -L ..\extensions\src\profilerhost_util -lprofilerHostUtil
    OBJ = obj
    LIBEXT = lib
    LIBPREFIX =
    BINEXT = .exe
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS = -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti -lnvperf_host -lnvperf_target -L ../extensions/src/profilerhost_util -lprofilerHostUtil
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti -lnvperf_host -lnvperf_target -L ../extensions/src/profilerhost_util -lprofilerHostUtil
    endif
    OBJ = o
    LIBEXT = a
    LIBPREFIX = lib
    BINEXT = 
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif

    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

# Gencode arguments
SMS ?= 70 72 75 80 86
# Generate SASS code for each SM architecture listed in $(SMS)
$(foreach sm,$(SMS),$(eval GENCODE_FLAGS += -gencode arch=compute_$(sm),code=sm_$(sm)))

cupti_metric_properties: simpleQuery.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ $^ $(LIBS) $(INCLUDES)

simpleQuery.$(OBJ): simpleQuery.cpp
	nvcc $(NVCC_COMPILER)  $(NVCCFLAGS) $(GENCODE_FLAGS) -c $(INCLUDES) $<

run: cupti_metric_properties
	./$<

clean:
ifeq ($(OS), Windows_NT)
	del cupti_metric_properties.exe cupti_metric_properties.lib cupti_metric_properties.exp simpleQuery.$(OBJ)
else
	rm -f cupti_metric_properties simpleQuery.$(OBJ)
endif

=== cuda_cupti/extras/CUPTI/samples/cupti_query/Makefile ===
#
# Copyright 2011-2018 NVIDIA Corporation. All rights reserved
# 
INCLUDES = -I../../../../include -I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths. 
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS), Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):$(LIB_PATH)
    LIBS= -lcuda -L $(LIB_PATH) -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS= -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti
    endif
    OBJ = o
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif
    
    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

cupti_query: cupti_query.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ cupti_query.$(OBJ) $(LIBS) $(INCLUDES)

cupti_query.$(OBJ): cupti_query.cpp
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -c $(INCLUDES) $<

run: cupti_query
	./$<

clean:
	rm -f cupti_query cupti_query.$(OBJ)

=== cuda_cupti/extras/CUPTI/samples/event_multi_gpu/Makefile ===
#
# Copyright 2014-2018 NVIDIA Corporation. All rights reserved.
# 
INCLUDES = -I../../../../include -I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths. 
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS),Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):$(LIB_PATH)
    LIBS= -lcuda -L $(LIB_PATH) -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS= -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti
    endif
    OBJ = o
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif
    
    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

event_multi_gpu: event_multi_gpu.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ event_multi_gpu.$(OBJ) $(LIBS) $(INCLUDES)

event_multi_gpu.$(OBJ): event_multi_gpu.cu
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -c $(INCLUDES) $<

run: event_multi_gpu
	./$<

clean:
	rm -f event_multi_gpu event_multi_gpu.$(OBJ)

=== cuda_cupti/extras/CUPTI/samples/event_sampling/Makefile ===
#
# Copyright 2011-2020 NVIDIA Corporation. All rights reserved
# 
INCLUDES = -I../../../../include -I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

TARGET_ARCH ?= $(HOST_ARCH)
TARGET_OS ?= $(shell uname | tr A-Z a-z)

# Set required library paths. 
# In the case of cross-compilation, set the libs to the correct ones under /usr/local/cuda/targets/<TARGET_ARCH>-<TARGET_OS>/lib

ifeq ($(OS),Windows_NT)
    LIB_PATH ?= ..\..\lib64
else
    ifneq ($(TARGET_ARCH), $(HOST_ARCH))
        INCLUDES += -I../../../../targets/$(HOST_ARCH)-$(shell uname | tr A-Z a-z)/include
        LIB_PATH ?= ../../../../targets/$(TARGET_ARCH)-$(TARGET_OS)/lib
        TARGET_CUDA_PATH = -L $(LIB_PATH)/stubs
    else
        EXTRAS_LIB_PATH := ../../lib64
        LIB_PATH ?= ../../../../lib64
    endif
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):$(LIB_PATH)
    LIBS= -lcuda -L $(LIB_PATH) -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
        LIBS= -Xlinker -framework -Xlinker cuda -L $(LIB_PATH) -lcupti
    else
        LIBS :=
        ifeq ($(HOST_ARCH), $(TARGET_ARCH))
            export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_PATH)
            LIBS = -L $(EXTRAS_LIB_PATH)
        endif
        LIBS += $(TARGET_CUDA_PATH) -lcuda -L $(LIB_PATH) -lcupti
    endif
    OBJ = o
endif

# Point to the necessary cross-compiler.
NVCCFLAGS :=
ifneq ($(TARGET_ARCH), $(HOST_ARCH))
    ifeq ($(TARGET_ARCH), aarch64)
        ifeq ($(TARGET_OS), linux)
            HOST_COMPILER ?= aarch64-linux-gnu-g++
        else ifeq ($(TARGET_OS),qnx)
            ifeq ($(QNX_HOST),)
                $(error ERROR - QNX_HOST must be passed to the QNX host toolchain)
            endif
            ifeq ($(QNX_TARGET),)
                $(error ERROR - QNX_TARGET must be passed to the QNX target toolchain)
            endif
            HOST_COMPILER ?= $(QNX_HOST)/usr/bin/q++
            NVCCFLAGS := --qpp-config 5.4.0,gcc_ntoaarch64le
        endif
    endif
    
    ifdef HOST_COMPILER
        NVCC_COMPILER = -ccbin $(HOST_COMPILER)
    endif
endif

# Gencode arguments
SMS ?= 35 37 50 52 53 60 61 62 70 72
# Generate SASS code for each SM architecture listed in $(SMS)
$(foreach sm,$(SMS),$(eval GENCODE_FLAGS += -gencode arch=compute_$(sm),code=sm_$(sm)))

event_sampling: event_sampling.$(OBJ)
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) -o $@ event_sampling.$(OBJ) $(LIBS) $(INCLUDES)

event_sampling.$(OBJ): event_sampling.cu
	nvcc $(NVCC_COMPILER) $(NVCCFLAGS) $(GENCODE_FLAGS) -c $(INCLUDES) $<

run: event_sampling
	./$<

clean:
	rm -f event_sampling event_sampling.$(OBJ)

=== debian/changelog ===
nvidia-cuda-toolkit (11.2.2-1ubuntu1) hirsute; urgency=medium

  * Add build dependency on libxdamage1

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 06 Apr 2021 20:41:26 +0000

nvidia-cuda-toolkit (11.2.2-1) unstable; urgency=medium

  * New upstream release 11.2.2 (Mar 2021).
  * The nsight-systems gui is only available on amd64.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 25 Mar 2021 11:48:42 +0100

nvidia-cuda-toolkit (11.2.1-2) unstable; urgency=medium

  * Fix prefixing component versions starting with 11.1.0.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 20 Feb 2021 11:33:19 +0100

nvidia-cuda-toolkit (11.2.1-1) unstable; urgency=medium

  * New upstream release 11.2.1 (Feb 2021).
  * Use a snapshot of openjdk-8-jre (8u275-b01-1~deb9u1) for amd64.
  * Get component versions from version.json.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 16 Feb 2021 02:14:51 +0100

nvidia-cuda-toolkit (11.2.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 26 Jan 2021 00:24:29 +0100

nvidia-cuda-toolkit (11.2.0-1) experimental; urgency=medium

  * New upstream release 11.2.0 (Dec 2020).
  * d/copyright: Synchronize with updated EULA.txt.
  * SOVERSION bump, rename library packages:
    - libaccinj64-11.1 => libaccinj64-11.2
    - libcuinj64-11.1 => libcuinj64-11.2
    - libcupti11.1 => libcupti11.2
    - libnvrtc11.1 => libnvrtc11.2
    - libnvvm3 => libnvvm4
  * Update Lintian overrides.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 18 Jan 2021 17:04:26 +0100

nvidia-cuda-toolkit (11.1.1-4) unstable; urgency=medium

  * Use cuda-gdb 11.1.105.
  * Use per-library SOVERSIONs.
  * Use individual library versions.
  * Use component versions for versioning most binary packages.
  * Remove toolkit upstream version from shlibs files.
  * Add (tesla-)460 driver as alternate dependency.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 18 Jan 2021 12:32:21 +0100

nvidia-cuda-toolkit (11.1.1-3) unstable; urgency=medium

  * Fix misspelled g++-10 dependency.  (Closes: #976077)
  * Use substitution for the default gcc version.
  * Overhaul component tarball handling.
  * Use a snapshot of openjdk-8-jre (8u272-b10-0+deb9u1) for amd64.
  * Bump Standards-Version to 4.5.1 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Thu, 03 Dec 2020 22:21:32 +0100

nvidia-cuda-toolkit (11.1.1-2) unstable; urgency=medium

  * Add cuda.pc.  (Closes: #930731)
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 19 Nov 2020 15:45:52 +0100

nvidia-cuda-toolkit (11.1.1-1) experimental; urgency=medium

  * New upstream release 11.1 Update 1 (Oct 2020).
    * Fixes CVE-2020-5991.  (Closes: #973543)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5094
  * Refresh cuda-gdb 11.0.221 patch.
  * Add gcc-10 (default) and clang-10 as supported compiler alternatives.
  * Driver 450.80.02 is sufficient.
  * Conflict with Ubuntu .deb packages from NVIDIA that cause file conflicts.
    (LP: #1901239)
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Nov 2020 22:23:18 +0100

nvidia-cuda-toolkit (11.1.0-1) experimental; urgency=medium

  * New upstream release 11.1 (Sept 2020).
  * d/copyright: Synchronize with updated EULA.txt.
  * Use the newer cuda-gdb 11.0.221 from nvidia-cuda-toolkit 11.0.3.
  * Documentation and manpages are not longer bundled, please refer to
    https://docs.nvidia.com/cuda instead.
  * Runtime SOVERSION bump: 11.0 => 11.1, rename core library packages.
  * Some core libraries are still at SOVERSION 11.0.
  * Delayed SOVERSION bump: 10 => 11, rename cusolver library packages.
  * Update symbols control files.
  * Ship new files.
  * Refresh patches and fix more typos.
  * Update Lintian overrides.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 05 Nov 2020 19:49:44 +0100

nvidia-cuda-toolkit (11.0.3-3) unstable; urgency=medium

  [ Andreas Beckmann ]
  * nvidia-cuda-dev: Promote libcuda1 to Depends.
  * Support building the docs on all architectures by taking the missing bits
    from amd64.

  [ Graham Inggs ]
  * Update libcuda1 availability for groovy (LP: #1900627)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Nov 2020 20:33:01 +0100

nvidia-cuda-toolkit (11.0.3-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 04 Nov 2020 10:29:15 +0100

nvidia-cuda-toolkit (10.2.89-5) unstable; urgency=medium

  * nvidia-cuda-dev, libnvidia-ml-dev: Set Multi-Arch: same.
    (Closes: #969962)
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 24 Sep 2020 21:41:41 +0200

=== debian/control ===
Source: nvidia-cuda-toolkit
Section: non-free/libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
 Graham Inggs <ginggs@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 quilt,
 chrpath,
 hardlink,
Build-Depends-Arch:
# for cuda-gdb
 bison,
 flex,
 libbabeltrace-dev,
 libbabeltrace-ctf-dev,
 libexpat1-dev,
 libipt-dev [amd64],
 liblzma-dev,
 libncurses-dev,
 libreadline-dev,
 python3-dev,
 texinfo,
 zlib1g-dev,
# for nsight-compute/nsight-systems
 libasound2-dev [!arm64],
 libdbus-1-3 [amd64],
 libegl1 [amd64],
 libfontconfig1 [amd64],
 libgl1 [amd64],
 libgssapi-krb5-2 [amd64],
 libnss3 [amd64],
 libssl1.1 [amd64],
 libxcomposite1 [amd64],
 libxcursor1 [amd64],
 libxdamage1 [amd64],
 libxkbcommon-x11-0 [amd64],
 libxi6 [!arm64],
 libxrandr2 [amd64],
 libxtst6 [!arm64],
# for nvidia-openjdk-8-jre
 libfreetype-dev [!arm64] | libfreetype6-dev [!arm64],
 libgif-dev [!arm64],
 libjpeg-dev (>= 1:0) [!arm64] | libjpeg62-dev [!arm64],
 liblcms2-dev [!arm64],
 libpulse-dev [!arm64],
 libpcsclite-dev [!arm64],
 libpng-dev [!arm64],
 libxrender-dev [!arm64],
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://developer.nvidia.com/cuda-zone
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-cuda-toolkit
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-cuda-toolkit.git
XS-Autobuild: yes

Package: nvidia-cuda-toolkit
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Depends:
 ${nvidia-profiler:eq:Version} [${cuda:arch:has-nvidia-profiler}],
 nvidia-cuda-dev (= ${binary:Version}),
 nvidia-opencl-dev (= ${binary:Version}) | opencl-dev,
 g++-${cuda:gcc:DefaultVersion} | g++-10 | clang-10 | g++-9 | clang-9 | g++-8 | clang-8 | clang-7 | g++-7 | clang-6.0 | clang (<< 1:11~) | g++-6 | g++-5,
 gcc-${cuda:gcc:DefaultVersion} | gcc-10 | clang-10 | gcc-9 | clang-9 | gcc-8 | clang-8 | clang-7 | gcc-7 | clang-6.0 | clang (<< 1:11~) | gcc-6 | gcc-5,
 ${shlibs:Depends}, ${misc:Depends},
Recommends:
 nvidia-cuda-toolkit-doc (= ${source:Version}),
 ${nvidia-cuda-gdb:eq:Version},
 ${nvidia-visual-profiler:eq:Version} [${cuda:arch:has-nvidia-visual-profiler}],
 ${nsight-compute:eq:Version},
 ${nsight-systems:eq:Version},
Suggests:
 ${package:driver},
Breaks:
 nvidia-cuda-doc (<< 10.2.89-3),
Description: NVIDIA CUDA development toolkit
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the nvcc compiler and other tools needed for building
 CUDA applications.
 .
 Running CUDA applications requires a supported NVIDIA GPU and the NVIDIA
 driver kernel module.

Package: nvidia-cuda-toolkit-gcc
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Depends:
 g++-${cuda:gcc:DefaultVersion},
 gcc-${cuda:gcc:DefaultVersion},
 nvidia-cuda-toolkit (= ${binary:Version}),
 ${misc:Depends},
Description: NVIDIA CUDA development toolkit (GCC compatibility)
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package provides the /usr/bin/cuda-gcc, /usr/bin/cuda-g++ symlinks to
 simplify building packages that need to be built with a CUDA-compatible
 compiler.

Package: nvidia-cuda-toolkit-doc
Section: non-free/doc
Architecture: all
Depends:
 libjs-html5shiv,
 libjs-jquery,
 ${misc:Depends}
Breaks:
 nvidia-cuda-doc (<< 10.2.89-3),
Replaces:
 nvidia-cuda-doc (<< 10.2.89-3),
Homepage: https://docs.nvidia.com/cuda
Description: NVIDIA CUDA and OpenCL documentation
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 Note that CUDA documentation is no longer bundled with CUDA toolkit releases.
 Visit https://docs.nvidia.com/cuda for the latest documentation on CUDA.

Package: nvidia-cuda-gdb
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-toolkit-doc (= ${source:Version})
Description: NVIDIA CUDA Debugger (GDB)
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the cuda-gdb debugger.

Package: nvidia-profiler
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 ${libaccinj64-:eq:Version},
 ${libcuinj64-:eq:Version},
 ${shlibs:Depends}, ${misc:Depends}
Suggests:
 nvidia-cuda-toolkit,
Description: NVIDIA Profiler for CUDA and OpenCL
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the nvprof profiler.

Package: nvidia-openjdk-8-jre
Section: non-free/java
Architecture: amd64 ppc64el
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 openjdk-8-jre-headless,
 openjdk-8-jre,
Replaces:
 openjdk-8-jre-headless,
 openjdk-8-jre,
Description: Obsolete OpenJDK Java runtime, for NVIDIA applications
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using Hotspot JIT.
 .
 This package provides OpenJDK-8 JRE binaries built on Debian for use with
 the NVIDIA CUDA Toolkit. This obsolete version is needed for
 nvidia-visual-profiler.

Package: nvidia-visual-profiler
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 ${jre:Depends},
 libgtk2.0-0,
 ${nvidia-profiler:eq:Version} [${cuda:arch:has-nvidia-profiler}],
 ${perl:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-toolkit-doc (= ${source:Version}),
Homepage: https://developer.nvidia.com/nvidia-visual-profiler
Description: NVIDIA Visual Profiler for CUDA and OpenCL
 The NVIDIA Visual Profiler is a cross-platform performance profiling tool
 that delivers developers vital feedback for optimizing CUDA C/C++ and OpenCL
 applications.

Package: nsight-compute
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Depends:
 libjs-html5shiv,
 libjs-jquery,
 ${nsight-compute-target:eq:Version},
 ${shlibs:Depends}, ${misc:Depends}
Homepage: https://developer.nvidia.com/nsight-compute
Description: NVIDIA Nsight Compute
 NVIDIA Nsight Compute is an interactive kernel profiler for CUDA applications.
 It provides detailed performance metrics and API debugging via a user
 interface and command line tool. In addition, its baseline feature allows
 users to compare results within the tool. Nsight Compute provides a
 customizable and data-driven user interface and metric collection and can be
 extended with analysis scripts for post-processing results.

Package: nsight-compute-target
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Multi-Arch: same
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Breaks:
 nsight-compute (<< 10.2.89-3),
Homepage: https://developer.nvidia.com/nsight-compute
Description: NVIDIA Nsight Compute (target specific libraries)
 NVIDIA Nsight Compute is an interactive kernel profiler for CUDA applications.
 It provides detailed performance metrics and API debugging via a user
 interface and command line tool. In addition, its baseline feature allows
 users to compare results within the tool. Nsight Compute provides a
 customizable and data-driven user interface and metric collection and can be
 extended with analysis scripts for post-processing results.
 .
 This package contains the target specific libraries.

Package: nsight-systems
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Depends:
 libjs-jquery,
 libjs-sphinxdoc,
 libjs-underscore,
 ${nsight-systems-target:eq:Version},
 ${shlibs:Depends}, ${misc:Depends}
Homepage: https://developer.nvidia.com/nsight-systems
Description: NVIDIA Nsight Systems
 NVIDIA Nsight Systems is a system-wide performance analysis tool designed to
 visualize an application’s algorithms, help you identify the largest
 opportunities to optimize, and tune to scale efficiently across any quantity
 or size of CPUs and GPUs; from large server to smallest SoCs.

Package: nsight-systems-target
Section: non-free/devel
Architecture: amd64 ppc64el arm64
Multi-Arch: same
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Breaks:
 nsight-systems (<< 10.2.89-3),
Homepage: https://developer.nvidia.com/nsight-systems
Description: NVIDIA Nsight Systems (target specific libraries)
 NVIDIA Nsight Systems is a system-wide performance analysis tool designed to
 visualize an application’s algorithms, help you identify the largest
 opportunities to optimize, and tune to scale efficiently across any quantity
 or size of CPUs and GPUs; from large server to smallest SoCs.
 .
 This package contains the target specific libraries.

Package: nvidia-cuda-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el arm64
Multi-Arch: same
Depends:
 ${libcudart:eq:Version},
 ${libaccinj64-:eq:Version} [${cuda:arch:has-nvidia-profiler}],
 ${libcuinj64-:eq:Version} [${cuda:arch:has-nvidia-profiler}],
 ${libnvrtc:eq:Version},
 ${libnvtoolsext:eq:Version},
 ${libnvvm:eq:Version},
 ${libcublas:eq:Version},
 ${libcublaslt:eq:Version},
 ${libnvblas:eq:Version},
 ${libcufft:eq:Version},
 ${libcufftw:eq:Version},
 ${libcurand:eq:Version},
 ${libcusolver:eq:Version},
 ${libcusolvermg:eq:Version},
 ${libcusparse:eq:Version},
 ${libnppc:eq:Version},
 ${libnppial:eq:Version},
 ${libnppicc:eq:Version},
 ${libnppidei:eq:Version},
 ${libnppif:eq:Version},
 ${libnppig:eq:Version},
 ${libnppim:eq:Version},
 ${libnppist:eq:Version},
 ${libnppisu:eq:Version},
 ${libnppitc:eq:Version},
 ${libnpps:eq:Version},
 ${libnvjpeg:eq:Version},
 ${libcupti-dev:eq:Version},
 ${libnvidia-ml-dev:eq:Version},
 libthrust-dev (>= ${thrust:Version}~),
 ${package:libcuda1},
 ${misc:Depends}
Recommends:
 libgl1-mesa-dev | libgl-dev,
 libvdpau-dev,
 libnvcuvid1,
Breaks:
 libcuda1 (<< ${nvidia:MinVersion}),
Description: NVIDIA CUDA development files
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the development files: headers and libraries.

Package: nvidia-opencl-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el arm64
Multi-Arch: same
Depends:
 ocl-icd-opencl-dev,
 ${misc:Depends}
Recommends:
 nvidia-opencl-icd,
Breaks:
 nvidia-libopencl1 (>> 0),
Description: NVIDIA OpenCL development files
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This metapackage provides the development files: headers and libraries.

Package: libnvidia-ml-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el arm64
Multi-Arch: same
Depends:
 ${package:libnvidia-ml1},
 ${misc:Depends}
Breaks:
 nvidia-cuda-dev (<< 10.1.168-4~),
Replaces:
 nvidia-cuda-dev (<< 10.1.168-4~),
Homepage: https://developer.nvidia.com/nvidia-management-library-NVML
Description: NVIDIA Management Library (NVML) development files
 The NVIDIA Management Library (NVML) provides a monitoring and management API.
 It provides a direct access to the queries and commands exposed via nvidia-smi.
 .
 This package contains the header file and depends on the driver-provided
 library.

Package: libcudart11.0
Architecture: amd64 ppc64el arm64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# most flags derived from gdb 8.2 in buster
# README.NVIDIA mentions --enable-targets="x86_64-apple-darwin,x86_64-unknown-linux-gnu,arm-elf-linux-gnu,m68k-unknown-linux-gnu"
CUDA_GDB_FLAGS	 = \
	--program-prefix=cuda- --with-gdb-datadir='$${prefix}/share/cuda-gdb' --with-jit-reader-dir='$${libdir}/cuda-gdb' --with-system-gdbinit='$${sysconfdir}/cuda-gdb/gdbinit' \
	--enable-cuda --enable-targets="$(DEB_HOST_GNU_TYPE),m68k-unknown-linux-gnu" --disable-nls \
	--disable-gdbtk --disable-shared --disable-readline --with-system-readline --with-expat --with-system-zlib --without-guile --with-babeltrace --enable-tui --with-lzma --with-python=python3 --enable-64-bit-bfd --disable-sim
ifneq (,$(filter $(DEB_HOST_ARCH),amd64))
CUDA_GDB_FLAGS	+= --with-intel-pt
endif

DEB_BUILD_MAINT_OPTIONS		 = hardening=+all
DEB_CPPFLAGS_MAINT_APPEND	 = -I$(CURDIR)/nvidia-cuda-tree-$(DEB_HOST_ARCH)/cuda_cudart/include
DEB_CFLAGS_MAINT_APPEND		 = -fcommon
DEB_LDFLAGS_MAINT_APPEND	 = -pthread

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

VENDOR			?= $(call dpkg_late_eval,VENDOR,dpkg-vendor --derives-from Ubuntu && echo Ubuntu || echo Debian)


aval			 = $(or $($(strip $1).$(or $(strip $2),$(DEB_HOST_ARCH))),$($(strip $1).default),$(error Not defined: $(strip $1)($(or $(strip $2),$(DEB_HOST_ARCH)))))
-include debian/rules.version
include debian/rules.soversion
include debian/rules.defs
CUDA_ARCH_LIST			?= amd64
CUDA_ARCH_LIST_NO_DRIVER	?=
CUDA_ARCH_LIST_NO_OPENJDK	?=
CUDA_VERSION_TOOLKIT	?= $(DEB_VERSION_UPSTREAM)
CUDA_VERSION_MAJOR	?= $(word 1,$(subst ., ,$(CUDA_VERSION_TOOLKIT)))
CUDA_VERSION_MINOR	?= $(word 2,$(subst ., ,$(CUDA_VERSION_TOOLKIT)))
version_driver		 = $(call aval,CUDA_VERSION_DRIVER_MINIMAL)
watch_url		 = $(CUDA_WATCH_URL)
PACKAGE_LIST		:= $(shell dh_listpackages)
CUDA_GDB_VERSION	?= $(CUDA_VERSION_cuda_gdb)
DEFAULT_GCC_VERSION	?= $(error Undefined DEFAULT_GCC_VERSION)
THRUST_VERSION		?= $(or $(strip $(shell perl -ne 'if (/define\s+THRUST_VERSION\s+(\d*)/) { printf "%d.%d.%d\n", $$1 / 100000, $$1 / 100 % 1000, $$1 % 100; }' nvidia-cuda/cuda_cudart/include/thrust/version.h)),$(error empty THRUST_VERSION))
CUDA_JAVA_HOME		?= /usr/lib/jvm/java-8-openjdk-$(DEB_HOST_ARCH)
libdir			 = usr/lib/$(DEB_HOST_MULTIARCH)
jre_pkg			?= $(filter nvidia-openjdk-8-jre,$(PACKAGE_LIST))
thrust_pkg		?= $(filter libthrust-dev,$(PACKAGE_LIST))
nvidia_profiler_pkg	?= $(filter nvidia-profiler,$(PACKAGE_LIST))
visual_profiler_pkg	?= $(filter nvidia-visual-profiler,$(PACKAGE_LIST))

export NSIGHT_COMPUTE_DESKTOP_DIR	 = $(NSIGHT_COMPUTE_DESKTOP_DIR.$(DEB_HOST_ARCH))
export NSIGHT_SYSTEMS_HOST_DIR		 = $(NSIGHT_SYSTEMS_HOST_DIR.$(DEB_HOST_ARCH))
export NSIGHT_SYSTEMS_TARGET_DIR	 = $(NSIGHT_SYSTEMS_TARGET_DIR.$(DEB_HOST_ARCH))

package_libcuda1	 = $(package_libcuda1.$(VENDOR))
package_libcuda1	+= libcuda.so.1 (>= $${nvidia:MinVersion}) |
package_libcuda1	+= libcuda-$(CUDA_VERSION_MAJOR).$(CUDA_VERSION_MINOR)-1 |
package_libcuda1	+= no-libcuda1 [$${cuda:arch:has-no-driver}] |

package_libnvidia-ml1	 = $(package_libnvidia-ml1.$(VENDOR))
package_libnvidia-ml1	+= libnvidia-ml.so.1 (>= $${nvidia:MinVersion}) |
package_libnvidia-ml1	+= no-libcuda1 [$${cuda:arch:has-no-driver}] |

package_driver		 = $(package_driver.$(VENDOR))

# do not build nvidia-openjdk-8-jre on Ubuntu
ifneq (,$(jre_pkg))
ifeq ($(VENDOR),Ubuntu)
export DH_OPTIONS := $(DH_OPTIONS) -N$(jre_pkg)
jre_pkg			 =
endif
endif

OPENJDK_VERSION		 = $(call aval,OPENJDK_VERSION,$(DEB_HOST_ARCH))
make_component_version	?= $(subst -deb,-d,$(subst +,-,$(subst ~,-,$1)))
get_openjdk_component		?= openjdk-8-$1-$(call make_component_version,$(call aval,OPENJDK_VERSION,$2))
get_openjdk_source_component	?= $(call get_openjdk_component,source,$1)
get_openjdk_jre_component	?= $(call get_openjdk_component,jre-$1,$1)

jre_pkg_dep		?= $(if $(jre_pkg),$(jre_pkg) (>= 9.+8u252))
jre_depends.Debian	?= $(if $(jre_pkg),$(jre_pkg_dep) |) openjdk-8-jre
jre_depends.Ubuntu	?= openjdk-8-jre | $(jre_pkg_dep)

ifneq (,$(jre_pkg))
$(jre_pkg).DEB_VERSION	 = 9.+$(OPENJDK_VERSION)
endif

ifneq (,$(thrust_pkg))
$(thrust_pkg).DEB_VERSION	 = $(THRUST_VERSION)
endif

TEMPLATES	:= $(wildcard debian/*.in debian/patches/*.in)
SOVERTEMPLATES	:= $(wildcard debian/*SOVER*)
AUTOGEN		+= $(patsubst %.in,%,$(TEMPLATES))
AUTOGEN		+= $(foreach t,$(sort $(patsubst %.in,%,$(SOVERTEMPLATES))),$(subst SOVER,$(or $($(firstword $(subst SOVER, ,$(notdir $t))).SOVERSION),XXX),$t))
AUTOGEN		+= debian/g++
AUTOKEEP	 = debian/watch
AUTOCLEAN	 = $(filter-out $(AUTOKEEP),$(AUTOGEN))
AUTOCLEAN	+= debian/shlibs.local


.PHONY: autogen prepare
autogen: $(AUTOGEN)
prepare: autogen unpack-stamp compare-copyright-license


# deep copy, files will get irreversibly modified via hardlinks in the build target
define nvidia-cuda-unpack-repack
	dh_testdir
	$(RM) -r $@ $@.tmp
	cp -a $1 $@
endef

nvidia-cuda-tree-%:
	$(call nvidia-cuda-unpack-$(call aval,CUDA_TAR_TYPE,$*),$*)

unpack-stamp: $(filter debian/patches%,$(AUTOGEN))
unpack-stamp: nvidia-cuda-tree-$(DEB_HOST_ARCH)
	$(RM) nvidia-cuda
	ln -sf nvidia-cuda-tree-$(DEB_HOST_ARCH) nvidia-cuda
	$(RM) -r cuda-gdb-$(CUDA_GDB_VERSION) cuda-gdb
ifneq (arm64,$(DEB_HOST_ARCH))
	tar xf nvidia-cuda/cuda_gdb/extras/cuda-gdb-$(CUDA_GDB_VERSION).src.tar.gz
else
	tar xf amd64/cuda_gdb/extras/cuda-gdb-$(CUDA_GDB_VERSION).src.tar.gz
endif
	mv cuda-gdb-$(CUDA_GDB_VERSION) cuda-gdb
ifneq (,$(jre_pkg))
	$(RM) -r openjdk-8-jre
	dpkg -x $(call get_openjdk_jre_component,$(DEB_HOST_ARCH))/openjdk-8-jre-headless_$(OPENJDK_VERSION)_$(DEB_HOST_ARCH).deb openjdk-8-jre
	dpkg -x $(call get_openjdk_jre_component,$(DEB_HOST_ARCH))/openjdk-8-jre_$(OPENJDK_VERSION)_$(DEB_HOST_ARCH).deb openjdk-8-jre
	cp openjdk-8-jre/usr/share/doc/openjdk-8-jre-headless/copyright debian/$(jre_pkg).copyright
endif
	QUILT_PATCHES=debian/patches QUILT_SERIES=series-postunpack quilt --quiltrc /dev/null push -a || test $$? = 2
	touch $@

# Reformat the EULA to the format needed for debian/copyright.
nvidia-cuda/EULA.txt: unpack-stamp
EULA.fmt: nvidia-cuda/EULA.txt
	cat $< \
		| fromdos | fromdos | expand \
		| iconv -f UTF-8 -t latin1//TRANSLIT \
		| fold -s -w 80 \
		| sed -e 's/ *$$//;s/^$$/./;s/^/ /;' \
		> $@

# Compare the license in debian/copyright with the EULA shipped in the archive.
compare-copyright-license: EULA.fmt
	sed -e '1,/^License: other-NVIDIA-CUDA-TOOLKIT/d; /^$$/,$$d; /^ .$$/d' debian/copyright > copyright.tmp
	sed -e '/^ .$$/d' EULA.fmt > EULA.tmp
	diff -w copyright.tmp EULA.tmp
	rm -f copyright.tmp EULA.tmp


.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install
binary binary-arch binary-indep build build-arch build-indep clean install:
	dh $@

build-stamp: unpack-stamp
	$(RM) -r build
	cp -al nvidia-cuda-tree-$(DEB_HOST_ARCH)/ build
	test -d build/libcublas/src || cp -alv amd64/libcublas/src build/libcublas/
	test -d build/libcusparse/src || cp -alv amd64/libcusparse/src build/libcusparse/
	test -d build/cuda_cupti/extras/CUPTI/doc/Cupti || cp -alv amd64/cuda_cupti/extras/CUPTI/doc build/cuda_cupti/extras/CUPTI/
	# fix permissions
ifneq (,$(visual_profiler_pkg))
	chmod -x build/cuda_nvvp/libnvvp/*.xpm
endif
	chmod -x build/cuda_nvcc/nvvm/libnvvm-samples/build.bat
	# remove rpath
	chrpath -d build/cuda_sanitizer_api/compute-sanitizer/libTreeLauncherTargetInjection.so
	# remove tracking scripts
	find build \( -name google-analytics-tracker.js -o -name google-analytics-write.js -o -name tynt.js \) -exec rm -v {} +
	# remove tracking images
	@set -e -x ; for dir in \
		build/nsight_compute/docs \
		build/cuda_cupti/extras/CUPTI/doc \
		build/cuda_sanitizer_api/compute-sanitizer/docs \
	; do test ! -d $$dir || find $$dir \
	    -name '*.html' -exec sed -r -i \
		-e '\,http://omniture.nvidia.com/b/ss/nvidiacudadocs/1/H.17--NS/0, { s,(<noscript>),<!-- \1,; s,img src,img DISABLED,; s,(</noscript>),\1 -->, }' \

=== debian/watch ===
version=4
opts=searchmode=plain https://developer.nvidia.com/cuda-downloads https?://[-./0-9a-zA-Z]+/local_installers/cuda_([0-9.]+)_[0-9.]+_linux(?:_[0-9a-zA-Z]+)?.run
